Loading...
Searching...
No Matches
cxx::Bits::Direction Struct Reference

The direction to go in a binary search tree. More...

`#include <bst_base.h>`

Collaboration diagram for cxx::Bits::Direction:

## Public Types

enum | Direction_e { L = 0 , R = 1 , N = 2 }
| The literal direction values. More...

## Public Member Functions

| Direction ()=default
| Uninitialized direction.
| Direction (Direction_e d)
| Convert a literal direction (L, R, N) to an object.
| Direction (bool b)
| Convert a boolean to a direction (false == L, true == R).
Direction | operator! () const
| Negate the direction.
Comparison operators (equality and inequality)
bool | operator== (Direction_e o) const
| Compare for equality.
bool | operator!= (Direction_e o) const
| Compare for inequality.
bool | operator== (Direction o) const
| Compare for equality.
bool | operator!= (Direction o) const
| Compare for inequality.

## Detailed Description

The direction to go in a binary search tree.

Definition at line 28 of file bst_base.h.

## Member Enumeration Documentation

## Direction_e

enum cxx::Bits::Direction::Direction_e

The literal direction values.

Enumerator
L | Go to the left child.
R | Go to the right child.
N | Stop.

Definition at line 31 of file bst_base.h.

## Member Function Documentation

## operator!()

Direction cxx::Bits::Direction::operator! | ( |  | ) | const

inline

Negate the direction.

Note
  This is only defined for a current value of L or R

Definition at line 52 of file bst_base.h.

References Direction().

Here is the call graph for this function:

The documentation for this struct was generated from the following file:

- l4/cxx/bits/bst_base.h